/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory CIA;
  public final Memory BRANCH;
  public final Memory SKIPOP;
  public final Memory NEXTPC;
  public final Memory GPR;
  public final Memory FPR;
  public final Memory SPR;
  public final Memory XER;
  public final Memory CSRR0;
  public final Memory CSRR1;
  public final Memory LR;
  public final Memory CTR;
  public final Memory DAC1;
  public final Memory DAC2;
  public final Memory DBCR0;
  public final Memory DBCR1;
  public final Memory DBCR2;
  public final Memory DBSR;
  public final Memory XER_SO;
  public final Memory XER_OV;
  public final Memory XER_CA;
  public final Memory CR;
  public final Memory CR0;
  public final Memory CR1;
  public final Memory CR2;
  public final Memory CR7;
  public final Memory CR0_LT;
  public final Memory CR0_GT;
  public final Memory CR0_EQ;
  public final Memory CR0_SO;
  public final Memory MEM;

  private PE() {
    super();
    this.CIA = Memory.def(Memory.Kind.REG, "CIA", TypeDefs.DWORD, 1);
    this.BRANCH = Memory.def(Memory.Kind.MEM, "BRANCH", TypeDefs.BIT, 1);
    this.SKIPOP = Memory.def(Memory.Kind.MEM, "SKIPOP", TypeDefs.BIT, 1);
    this.NEXTPC = Memory.def(Memory.Kind.MEM, "NEXTPC", TypeDefs.DWORD, 1);
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.WORD, 32);
    this.FPR = Memory.def(Memory.Kind.REG, "FPR", TypeDefs.DWORD, 32);
    this.SPR = Memory.def(Memory.Kind.REG, "SPR", TypeDefs.DWORD, 1024);
    this.XER = Memory.def(Memory.Kind.REG, "XER", TypeDefs.DWORD, 1, SPR.access(1));
    this.CSRR0 = Memory.def(Memory.Kind.REG, "CSRR0", TypeDefs.DWORD, 1, SPR.access(58));
    this.CSRR1 = Memory.def(Memory.Kind.REG, "CSRR1", TypeDefs.DWORD, 1, SPR.access(59));
    this.LR = Memory.def(Memory.Kind.REG, "LR", TypeDefs.DWORD, 1, SPR.access(8));
    this.CTR = Memory.def(Memory.Kind.REG, "CTR", TypeDefs.DWORD, 1, SPR.access(9));
    this.DAC1 = Memory.def(Memory.Kind.REG, "DAC1", TypeDefs.DWORD, 1, SPR.access(316));
    this.DAC2 = Memory.def(Memory.Kind.REG, "DAC2", TypeDefs.DWORD, 1, SPR.access(317));
    this.DBCR0 = Memory.def(Memory.Kind.REG, "DBCR0", TypeDefs.DWORD, 1, SPR.access(308));
    this.DBCR1 = Memory.def(Memory.Kind.REG, "DBCR1", TypeDefs.DWORD, 1, SPR.access(309));
    this.DBCR2 = Memory.def(Memory.Kind.REG, "DBCR2", TypeDefs.DWORD, 1, SPR.access(310));
    this.DBSR = Memory.def(Memory.Kind.REG, "DBSR", TypeDefs.DWORD, 1, SPR.access(304));
    this.XER_SO = Memory.def(Memory.Kind.REG, "XER_SO", TypeDefs.BIT, 1, XER.access().bitField(0, 0));
    this.XER_OV = Memory.def(Memory.Kind.REG, "XER_OV", TypeDefs.BIT, 1, XER.access().bitField(1, 1));
    this.XER_CA = Memory.def(Memory.Kind.REG, "XER_CA", TypeDefs.BIT, 1, XER.access().bitField(2, 2));
    this.CR = Memory.def(Memory.Kind.REG, "CR", TypeDefs.WORD, 1);
    this.CR0 = Memory.def(Memory.Kind.REG, "CR0", Type.CARD(4), 1, CR.access().bitField(3, 0));
    this.CR1 = Memory.def(Memory.Kind.REG, "CR1", Type.CARD(4), 1, CR.access().bitField(7, 4));
    this.CR2 = Memory.def(Memory.Kind.REG, "CR2", Type.CARD(4), 1, CR.access().bitField(11, 8));
    this.CR7 = Memory.def(Memory.Kind.REG, "CR7", Type.CARD(4), 1, CR.access().bitField(31, 28));
    this.CR0_LT = Memory.def(Memory.Kind.REG, "CR0_LT", TypeDefs.BIT, 1, CR0.access().bitField(0, 0));
    this.CR0_GT = Memory.def(Memory.Kind.REG, "CR0_GT", TypeDefs.BIT, 1, CR0.access().bitField(1, 1));
    this.CR0_EQ = Memory.def(Memory.Kind.REG, "CR0_EQ", TypeDefs.BIT, 1, CR0.access().bitField(2, 2));
    this.CR0_SO = Memory.def(Memory.Kind.REG, "CR0_SO", TypeDefs.BIT, 1, CR0.access().bitField(3, 3));
    this.MEM = Memory.def(Memory.Kind.MEM, "MEM", TypeDefs.WORD, 0x40000000);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    super(other);
    this.CIA = other.CIA.copy();
    this.BRANCH = other.BRANCH.copy();
    this.SKIPOP = other.SKIPOP.copy();
    this.NEXTPC = other.NEXTPC.copy();
    this.GPR = other.GPR.copy();
    this.FPR = other.FPR.copy();
    this.SPR = other.SPR.copy();
    this.XER = Memory.def(Memory.Kind.REG, "XER", TypeDefs.DWORD, 1, SPR.access(1));
    this.CSRR0 = Memory.def(Memory.Kind.REG, "CSRR0", TypeDefs.DWORD, 1, SPR.access(58));
    this.CSRR1 = Memory.def(Memory.Kind.REG, "CSRR1", TypeDefs.DWORD, 1, SPR.access(59));
    this.LR = Memory.def(Memory.Kind.REG, "LR", TypeDefs.DWORD, 1, SPR.access(8));
    this.CTR = Memory.def(Memory.Kind.REG, "CTR", TypeDefs.DWORD, 1, SPR.access(9));
    this.DAC1 = Memory.def(Memory.Kind.REG, "DAC1", TypeDefs.DWORD, 1, SPR.access(316));
    this.DAC2 = Memory.def(Memory.Kind.REG, "DAC2", TypeDefs.DWORD, 1, SPR.access(317));
    this.DBCR0 = Memory.def(Memory.Kind.REG, "DBCR0", TypeDefs.DWORD, 1, SPR.access(308));
    this.DBCR1 = Memory.def(Memory.Kind.REG, "DBCR1", TypeDefs.DWORD, 1, SPR.access(309));
    this.DBCR2 = Memory.def(Memory.Kind.REG, "DBCR2", TypeDefs.DWORD, 1, SPR.access(310));
    this.DBSR = Memory.def(Memory.Kind.REG, "DBSR", TypeDefs.DWORD, 1, SPR.access(304));
    this.XER_SO = Memory.def(Memory.Kind.REG, "XER_SO", TypeDefs.BIT, 1, XER.access().bitField(0, 0));
    this.XER_OV = Memory.def(Memory.Kind.REG, "XER_OV", TypeDefs.BIT, 1, XER.access().bitField(1, 1));
    this.XER_CA = Memory.def(Memory.Kind.REG, "XER_CA", TypeDefs.BIT, 1, XER.access().bitField(2, 2));
    this.CR = other.CR.copy();
    this.CR0 = Memory.def(Memory.Kind.REG, "CR0", Type.CARD(4), 1, CR.access().bitField(3, 0));
    this.CR1 = Memory.def(Memory.Kind.REG, "CR1", Type.CARD(4), 1, CR.access().bitField(7, 4));
    this.CR2 = Memory.def(Memory.Kind.REG, "CR2", Type.CARD(4), 1, CR.access().bitField(11, 8));
    this.CR7 = Memory.def(Memory.Kind.REG, "CR7", Type.CARD(4), 1, CR.access().bitField(31, 28));
    this.CR0_LT = Memory.def(Memory.Kind.REG, "CR0_LT", TypeDefs.BIT, 1, CR0.access().bitField(0, 0));
    this.CR0_GT = Memory.def(Memory.Kind.REG, "CR0_GT", TypeDefs.BIT, 1, CR0.access().bitField(1, 1));
    this.CR0_EQ = Memory.def(Memory.Kind.REG, "CR0_EQ", TypeDefs.BIT, 1, CR0.access().bitField(2, 2));
    this.CR0_SO = Memory.def(Memory.Kind.REG, "CR0_SO", TypeDefs.BIT, 1, CR0.access().bitField(3, 3));
    this.MEM = other.MEM.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(CIA);
    addStorage(BRANCH);
    addStorage(SKIPOP);
    addStorage(NEXTPC);
    addStorage(GPR);
    addStorage(FPR);
    addStorage(SPR);
    addStorage(XER);
    addStorage(CSRR0);
    addStorage(CSRR1);
    addStorage(LR);
    addStorage(CTR);
    addStorage(DAC1);
    addStorage(DAC2);
    addStorage(DBCR0);
    addStorage(DBCR1);
    addStorage(DBCR2);
    addStorage(DBSR);
    addStorage(XER_SO);
    addStorage(XER_OV);
    addStorage(XER_CA);
    addStorage(CR);
    addStorage(CR0);
    addStorage(CR1);
    addStorage(CR2);
    addStorage(CR7);
    addStorage(CR0_LT);
    addStorage(CR0_GT);
    addStorage(CR0_EQ);
    addStorage(CR0_SO);
    addStorage(MEM);

    addLabel(new Label("PC", CIA, 0));
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
