/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.TemporaryVariables;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code TempVars} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TempVars extends TemporaryVariables {
  public final Memory gpr_reg_number;
  public final Memory OPCD;
  public final Memory temp_bit;
  public final Memory temp_bit0;
  public final Memory temp6;
  public final Memory temp;
  public final Memory temp0;
  public final Memory temp1;
  public final Memory temp2;
  public final Memory temp3;
  public final Memory tempI;
  public final Memory temp64;
  public final Memory temp64_0;
  public final Memory temp64_1;
  public final Memory temp64_2;
  public final Memory temp64_3;
  public final Memory tempL;
  public final Memory temp_fp_s;
  public final Memory temp_fp_s2;
  public final Memory temp_fp_d;
  public final Memory temp_fp_d2;
  public final Memory temp128;
  public final Memory temp128_0;
  public final Memory temp128_1;
  public final Memory temp128_2;
  public final Memory temp33;
  public final Memory temp65;
  public final Memory upd_flag_mmu;
  public final Memory LK;
  public final Memory AA;
  public final Memory BXO_10;
  public final Memory XO_9;
  public final Memory XO_10;
  public final Memory Rc;
  public final Memory OE;

  private TempVars() {
    this.gpr_reg_number = Memory.def(Memory.Kind.VAR, "gpr_reg_number", Type.CARD(5), 1);
    this.OPCD = Memory.def(Memory.Kind.VAR, "OPCD", Type.CARD(6), 1);
    this.temp_bit = Memory.def(Memory.Kind.VAR, "temp_bit", TypeDefs.BIT, 1);
    this.temp_bit0 = Memory.def(Memory.Kind.VAR, "temp_bit0", TypeDefs.BIT, 1);
    this.temp6 = Memory.def(Memory.Kind.VAR, "temp6", Type.CARD(6), 1);
    this.temp = Memory.def(Memory.Kind.VAR, "temp", TypeDefs.WORD, 1);
    this.temp0 = Memory.def(Memory.Kind.VAR, "temp0", TypeDefs.WORD, 1);
    this.temp1 = Memory.def(Memory.Kind.VAR, "temp1", TypeDefs.WORD, 1);
    this.temp2 = Memory.def(Memory.Kind.VAR, "temp2", TypeDefs.WORD, 1);
    this.temp3 = Memory.def(Memory.Kind.VAR, "temp3", TypeDefs.WORD, 1);
    this.tempI = Memory.def(Memory.Kind.VAR, "tempI", TypeDefs.INT, 1);
    this.temp64 = Memory.def(Memory.Kind.VAR, "temp64", TypeDefs.DWORD, 1);
    this.temp64_0 = Memory.def(Memory.Kind.VAR, "temp64_0", TypeDefs.DWORD, 1);
    this.temp64_1 = Memory.def(Memory.Kind.VAR, "temp64_1", TypeDefs.DWORD, 1);
    this.temp64_2 = Memory.def(Memory.Kind.VAR, "temp64_2", TypeDefs.DWORD, 1);
    this.temp64_3 = Memory.def(Memory.Kind.VAR, "temp64_3", TypeDefs.DWORD, 1);
    this.tempL = Memory.def(Memory.Kind.VAR, "tempL", TypeDefs.LONG, 1);
    this.temp_fp_s = Memory.def(Memory.Kind.VAR, "temp_fp_s", TypeDefs.FLOAT32, 1);
    this.temp_fp_s2 = Memory.def(Memory.Kind.VAR, "temp_fp_s2", TypeDefs.FLOAT32, 1);
    this.temp_fp_d = Memory.def(Memory.Kind.VAR, "temp_fp_d", TypeDefs.FLOAT64, 1);
    this.temp_fp_d2 = Memory.def(Memory.Kind.VAR, "temp_fp_d2", TypeDefs.FLOAT64, 1);
    this.temp128 = Memory.def(Memory.Kind.VAR, "temp128", TypeDefs.QWORD, 1);
    this.temp128_0 = Memory.def(Memory.Kind.VAR, "temp128_0", TypeDefs.QWORD, 1);
    this.temp128_1 = Memory.def(Memory.Kind.VAR, "temp128_1", TypeDefs.QWORD, 1);
    this.temp128_2 = Memory.def(Memory.Kind.VAR, "temp128_2", TypeDefs.QWORD, 1);
    this.temp33 = Memory.def(Memory.Kind.VAR, "temp33", Type.CARD(33), 1);
    this.temp65 = Memory.def(Memory.Kind.VAR, "temp65", Type.CARD(65), 1);
    this.upd_flag_mmu = Memory.def(Memory.Kind.VAR, "upd_flag_mmu", TypeDefs.BIT, 1);
    this.LK = Memory.def(Memory.Kind.VAR, "LK", TypeDefs.BIT, 1);
    this.AA = Memory.def(Memory.Kind.VAR, "AA", TypeDefs.BIT, 1);
    this.BXO_10 = Memory.def(Memory.Kind.VAR, "BXO_10", Type.CARD(10), 1);
    this.XO_9 = Memory.def(Memory.Kind.VAR, "XO_9", Type.CARD(9), 1);
    this.XO_10 = Memory.def(Memory.Kind.VAR, "XO_10", Type.CARD(10), 1);
    this.Rc = Memory.def(Memory.Kind.VAR, "Rc", TypeDefs.BIT, 1);
    this.OE = Memory.def(Memory.Kind.VAR, "OE", TypeDefs.BIT, 1);

    addVariable(gpr_reg_number);
    addVariable(OPCD);
    addVariable(temp_bit);
    addVariable(temp_bit0);
    addVariable(temp6);
    addVariable(temp);
    addVariable(temp0);
    addVariable(temp1);
    addVariable(temp2);
    addVariable(temp3);
    addVariable(tempI);
    addVariable(temp64);
    addVariable(temp64_0);
    addVariable(temp64_1);
    addVariable(temp64_2);
    addVariable(temp64_3);
    addVariable(tempL);
    addVariable(temp_fp_s);
    addVariable(temp_fp_s2);
    addVariable(temp_fp_d);
    addVariable(temp_fp_d2);
    addVariable(temp128);
    addVariable(temp128_0);
    addVariable(temp128_1);
    addVariable(temp128_2);
    addVariable(temp33);
    addVariable(temp65);
    addVariable(upd_flag_mmu);
    addVariable(LK);
    addVariable(AA);
    addVariable(BXO_10);
    addVariable(XO_9);
    addVariable(XO_10);
    addVariable(Rc);
    addVariable(OE);
  }

  private static final class TempVarsFactory implements Factory {
    @Override
    public TempVars create() {
      return new TempVars();
    }
  }

  public static Factory newFactory() {
    return new TempVarsFactory();
  }
}
