/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.ba;
import ru.ispras.microtesk.model.api.Immediate;
import ru.ispras.microtesk.model.powerpc.op.branch_general;

/**
 * The {@code DecoderBa} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBa extends DecoderItem {
  private static DecoderBa instance = null;

  public static DecoderBa get() {
    if (null == instance) {
      instance = new DecoderBa();
    }
    return instance;
  }

  private DecoderBa() {
    super(
        32,
        true,
        "01001000000000000000000000000010",
        "11111100000000000000000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate LI = null;

    final branch_general branch_general_instance;
    branch_general_instance = (branch_general) readNextPrimitive(image, DecoderBranch_general.get());
    if (null == branch_general_instance) {
      return null;
    }
    LI = branch_general_instance.LI_op;

    return newResult(new ba(LI));
  }
}
