/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.bclrl;
import ru.ispras.microtesk.model.api.Immediate;
import ru.ispras.microtesk.model.powerpc.op.bclr_general;

/**
 * The {@code DecoderBclrl} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBclrl extends DecoderItem {
  private static DecoderBclrl instance = null;

  public static DecoderBclrl get() {
    if (null == instance) {
      instance = new DecoderBclrl();
    }
    return instance;
  }

  private DecoderBclrl() {
    super(
        32,
        true,
        "01001100000000000000000000100001",
        "11111100000000001110011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate BO = null;
    Immediate BI = null;
    Immediate BH = null;

    final bclr_general bclr_general_instance;
    bclr_general_instance = (bclr_general) readNextPrimitive(image, DecoderBclr_general.get());
    if (null == bclr_general_instance) {
      return null;
    }
    BO = bclr_general_instance.BO_op;
    BI = bclr_general_instance.BI_op;
    BH = bclr_general_instance.BH_op;

    return newResult(new bclrl(BO, BI, BH));
  }
}
