/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.or_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.or_general;

/**
 * The {@code DecoderOr_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderOr_d extends DecoderItem {
  private static DecoderOr_d instance = null;

  public static DecoderOr_d get() {
    if (null == instance) {
      instance = new DecoderOr_d();
    }
    return instance;
  }

  private DecoderOr_d() {
    super(
        32,
        true,
        "01111100000000000000001101111001",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R ra = null;
    R rs = null;
    R rb = null;

    final or_general or_general_instance;
    or_general_instance = (or_general) readNextPrimitive(image, DecoderOr_general.get());
    if (null == or_general_instance) {
      return null;
    }
    ra = or_general_instance.ra;
    rs = or_general_instance.rs;
    rb = or_general_instance.rb;

    return newResult(new or_d(ra, rs, rb));
  }
}
