/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.rlwinm;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.api.Immediate;
import ru.ispras.microtesk.model.powerpc.op.rlwinm_general;

/**
 * The {@code DecoderRlwinm} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderRlwinm extends DecoderItem {
  private static DecoderRlwinm instance = null;

  public static DecoderRlwinm get() {
    if (null == instance) {
      instance = new DecoderRlwinm();
    }
    return instance;
  }

  private DecoderRlwinm() {
    super(
        32,
        true,
        "01010100000000000000000000000000",
        "11111100000000000000000000000001"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R ra = null;
    R rs = null;
    Immediate SH = null;
    Immediate MB = null;
    Immediate ME = null;

    final rlwinm_general rlwinm_general_instance;
    rlwinm_general_instance = (rlwinm_general) readNextPrimitive(image, DecoderRlwinm_general.get());
    if (null == rlwinm_general_instance) {
      return null;
    }
    ra = rlwinm_general_instance.ra;
    rs = rlwinm_general_instance.rs;
    SH = rlwinm_general_instance.SH;
    MB = rlwinm_general_instance.MB;
    ME = rlwinm_general_instance.ME;

    return newResult(new rlwinm(ra, rs, SH, MB, ME));
  }
}
