/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.srawi_general;
import ru.ispras.microtesk.model.api.Immediate;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderSrawi_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSrawi_general extends DecoderItem {
  private static DecoderSrawi_general instance = null;

  public static DecoderSrawi_general get() {
    if (null == instance) {
      instance = new DecoderSrawi_general();
    }
    return instance;
  }

  private DecoderSrawi_general() {
    super(
        32,
        true,
        "01111100000000000000011001110000",
        "11111100000000000000011111111110"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate Rc_op = null;
    R ra = null;
    R rs = null;
    Immediate SH = null;

    if (!matchNextOpc(image, BitVector.valueOf("011111", 2, 6))) {
      return null;
    }

    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }

    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }

    SH = readNextImmediate(image, SHIFT);

    if (!matchNextOpc(image, BitVector.valueOf("1100111000", 2, 10))) {
      return null;
    }

    Rc_op = readNextImmediate(image, BIT);

    return newResult(new srawi_general(Rc_op, ra, rs, SH));
  }
}
