/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.stw;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.api.Immediate;
import ru.ispras.microtesk.model.powerpc.op.sl_general_image;

/**
 * The {@code DecoderStw} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderStw extends DecoderItem {
  private static DecoderStw instance = null;

  public static DecoderStw get() {
    if (null == instance) {
      instance = new DecoderStw();
    }
    return instance;
  }

  private DecoderStw() {
    super(
        32,
        true,
        "10010000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rs = null;
    Immediate D = null;
    R ra = null;

    final sl_general_image sl_general_image_instance;
    sl_general_image_instance = (sl_general_image) readNextPrimitive(image, DecoderSl_general_image.get());
    if (null == sl_general_image_instance) {
      return null;
    }
    rs = sl_general_image_instance.rsd;
    D = sl_general_image_instance.D;
    ra = sl_general_image_instance.ra;

    return newResult(new stw(rs, D, ra));
  }
}
