/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.subfo;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.subf_general;

/**
 * The {@code DecoderSubfo} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSubfo extends DecoderItem {
  private static DecoderSubfo instance = null;

  public static DecoderSubfo get() {
    if (null == instance) {
      instance = new DecoderSubfo();
    }
    return instance;
  }

  private DecoderSubfo() {
    super(
        32,
        true,
        "01111100000000000000010001010000",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rd = null;
    R ra = null;
    R rb = null;

    final subf_general subf_general_instance;
    subf_general_instance = (subf_general) readNextPrimitive(image, DecoderSubf_general.get());
    if (null == subf_general_instance) {
      return null;
    }
    rd = subf_general_instance.rd;
    ra = subf_general_instance.ra;
    rb = subf_general_instance.rb;

    return newResult(new subfo(rd, ra, rb));
  }
}
