/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.powerpc.op.xor;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.xor_general;

/**
 * The {@code DecoderXor} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderXor extends DecoderItem {
  private static DecoderXor instance = null;

  public static DecoderXor get() {
    if (null == instance) {
      instance = new DecoderXor();
    }
    return instance;
  }

  private DecoderXor() {
    super(
        32,
        true,
        "01111100000000000000001001111000",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R ra = null;
    R rs = null;
    R rb = null;

    final xor_general xor_general_instance;
    xor_general_instance = (xor_general) readNextPrimitive(image, DecoderXor_general.get());
    if (null == xor_general_instance) {
      return null;
    }
    ra = xor_general_instance.ra;
    rs = xor_general_instance.rs;
    rb = xor_general_instance.rb;

    return newResult(new xor(ra, rs, rb));
  }
}
