/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class bclr extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bclr",
          bclr.class,
          null
          );
      addArgument("BO", SHIFT);
      addArgument("BI", SHIFT);
      addArgument("BH", Type.CARD(2));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO = (Immediate) getArgument("BO", args);
      final Immediate BI = (Immediate) getArgument("BI", args);
      final Immediate BH = (Immediate) getArgument("BH", args);

      return new bclr(BO, BI, BH);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "bclr",
          instruction.class,
          null
          );
      addArgument("BO", SHIFT);
      addArgument("BI", SHIFT);
      addArgument("BH", Type.CARD(2));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO = (Immediate) getArgument("BO", args);
      final Immediate BI = (Immediate) getArgument("BI", args);
      final Immediate BH = (Immediate) getArgument("BH", args);

      return new instruction(
        new bclr(
          BO,
          BI,
          BH
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate BO;
  public final Immediate BI;
  public final Immediate BH;

  public bclr(final Immediate BO, final Immediate BI, final Immediate BH) {
    assert SHIFT.equals(BO.getType());
    assert SHIFT.equals(BI.getType());
    assert Type.CARD(2).equals(BH.getType());

    this.BO = BO;
    this.BI = BI;
    this.BH = BH;

    addArgument("BO", BO);
    addArgument("BI", BI);
    addArgument("BH", BH);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.LK.access().store(Data.valueOf(BIT, 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("bclr %s", new bclr_general(BO, BI, BH, new Immediate(vars__.LK.access())).syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new bclr_general(BO, BI, BH, new Immediate(vars__.LK.access())).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new bclr_general(BO, BI, BH, new Immediate(vars__.LK.access())).execute(pe__, vars__);
  }
}