/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class bclr_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bclr_general",
          bclr_general.class,
          null
          );
      addArgument("BO_op", SHIFT);
      addArgument("BI_op", SHIFT);
      addArgument("BH_op", Type.CARD(2));
      addArgument("LK_op", BIT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO_op = (Immediate) getArgument("BO_op", args);
      final Immediate BI_op = (Immediate) getArgument("BI_op", args);
      final Immediate BH_op = (Immediate) getArgument("BH_op", args);
      final Immediate LK_op = (Immediate) getArgument("LK_op", args);

      return new bclr_general(BO_op, BI_op, BH_op, LK_op);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate BO_op;
  public final Immediate BI_op;
  public final Immediate BH_op;
  public final Immediate LK_op;

  public bclr_general(final Immediate BO_op, final Immediate BI_op, final Immediate BH_op, final Immediate LK_op) {
    assert SHIFT.equals(BO_op.getType());
    assert SHIFT.equals(BI_op.getType());
    assert Type.CARD(2).equals(BH_op.getType());
    assert BIT.equals(LK_op.getType());

    this.BO_op = BO_op;
    this.BI_op = BI_op;
    this.BH_op = BH_op;
    this.LK_op = LK_op;

    addArgument("BO_op", BO_op);
    addArgument("BI_op", BI_op);
    addArgument("BH_op", BH_op);
    addArgument("LK_op", LK_op);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x13));
    vars__.BXO_10.access().store(Data.valueOf(Type.CARD(10), 0x10));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%d %d %d", BO_op.access().load().bigIntegerValue(), BI_op.access().load().bigIntegerValue(), BH_op.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%5s%5s000%2s%10s%1s", vars__.OPCD.access().load().toString(), BO_op.access().load().toString(), BI_op.access().load().toString(), BH_op.access().load().toString(), vars__.BXO_10.access().load().toString(), LK_op.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
    if (BO_op.access().bitField(2, 2).load().equals(Data.valueOf(BIT, 0x0))) {
      pe__.CTR.access().store(pe__.CTR.access().load().subtract(Data.valueOf(DWORD, 0x1)));
    }
    if (pe__.CTR.access().bitField(63, 0).load().equals(Data.valueOf(DWORD, 0x0))) {
      vars__.temp_bit.access().store(BO_op.access().bitField(2, 2).load().or(BO_op.access().bitField(1, 1).load()));
    } else {
      vars__.temp_bit.access().store(BO_op.access().bitField(2, 2).load().or(BO_op.access().bitField(1, 1).load().not()));
    }
    if (pe__.CR.access().load().shiftLeft(Data.valueOf(SHIFT, 0x1f).subtract(BI_op.access().load())).shiftRight(Data.valueOf(WORD, 0x1f)).equals(Data.zeroExtend(WORD, BO_op.access().bitField(3, 3).load()))) {
      vars__.temp_bit0.access().store(Data.valueOf(BIT, 0x1));
    } else {
      vars__.temp_bit0.access().store(BO_op.access().bitField(4, 4).load());
    }
    if (!vars__.temp_bit.access().load().and(vars__.temp_bit0.access().load()).equals(Data.valueOf(BIT, 0x0))) {
      pe__.NEXTPC.access().store(pe__.LR.access().load().shiftRight(Data.valueOf(DWORD, 0x2)).shiftLeft(Data.valueOf(DWORD, 0x2)));
    } else {
      pe__.NEXTPC.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
    if (LK_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.LR.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
  }
}