/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class branch_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "branch_general",
          branch_general.class,
          null
          );
      addArgument("LK_op", BIT);
      addArgument("AA_op", BIT);
      addArgument("LI_op", Type.CARD(24));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate LK_op = (Immediate) getArgument("LK_op", args);
      final Immediate AA_op = (Immediate) getArgument("AA_op", args);
      final Immediate LI_op = (Immediate) getArgument("LI_op", args);

      return new branch_general(LK_op, AA_op, LI_op);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate LK_op;
  public final Immediate AA_op;
  public final Immediate LI_op;

  public branch_general(final Immediate LK_op, final Immediate AA_op, final Immediate LI_op) {
    assert BIT.equals(LK_op.getType());
    assert BIT.equals(AA_op.getType());
    assert Type.CARD(24).equals(LI_op.getType());

    this.LK_op = LK_op;
    this.AA_op = AA_op;
    this.LI_op = LI_op;

    addArgument("LK_op", LK_op);
    addArgument("AA_op", AA_op);
    addArgument("LI_op", LI_op);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x12));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("<label>%d", LI_op.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%24s%1s%1s", vars__.OPCD.access().load().toString(), LI_op.access().load().toString(), AA_op.access().load().toString(), LK_op.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
    vars__.temp.access().store(Data.signExtend(WORD, Data.zeroExtend(Type.CARD(26), LI_op.access().load()).shiftLeft(Data.valueOf(Type.CARD(26), 0x2))));
    if (AA_op.access().load().equals(Data.valueOf(BIT, 0x0))) {
      pe__.NEXTPC.access().bitField(31, 0).store(vars__.temp.access().load().add(pe__.CIA.access().bitField(31, 0).load()));
    } else {
      pe__.NEXTPC.access().bitField(31, 0).store(vars__.temp.access().load());
    }
    if (LK_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.LR.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
  }
}