/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class rlwinm_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "rlwinm_general",
          rlwinm_general.class,
          null
          );
      addArgument("Rc_op", BIT);
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
      addArgument("MB", SHIFT);
      addArgument("ME", SHIFT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate Rc_op = (Immediate) getArgument("Rc_op", args);
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);
      final Immediate MB = (Immediate) getArgument("MB", args);
      final Immediate ME = (Immediate) getArgument("ME", args);

      return new rlwinm_general(Rc_op, ra, rs, SH, MB, ME);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate Rc_op;
  public final R ra;
  public final R rs;
  public final Immediate SH;
  public final Immediate MB;
  public final Immediate ME;

  public rlwinm_general(final Immediate Rc_op, final R ra, final R rs, final Immediate SH, final Immediate MB, final Immediate ME) {
    assert BIT.equals(Rc_op.getType());
    assert R.INFO.isSupported(ra);
    assert R.INFO.isSupported(rs);
    assert SHIFT.equals(SH.getType());
    assert SHIFT.equals(MB.getType());
    assert SHIFT.equals(ME.getType());

    this.Rc_op = Rc_op;
    this.ra = ra;
    this.rs = rs;
    this.SH = SH;
    this.MB = MB;
    this.ME = ME;

    addArgument("Rc_op", Rc_op);
    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("SH", SH);
    addArgument("MB", MB);
    addArgument("ME", ME);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x15));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s, %s, %d, %d, %d", ra.syntax(vars__), rs.syntax(vars__), SH.access().load().bigIntegerValue(), MB.access().load().bigIntegerValue(), ME.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%5s%5s%5s%5s%5s%1s", vars__.OPCD.access().load().toString(), rs.image(vars__), ra.image(vars__), SH.access().load().toString(), MB.access().load().toString(), ME.access().load().toString(), Rc_op.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if ((ME.access().load().compareTo(MB.access().load()) >= 0)) {
      vars__.temp.access().store(Data.valueOf(WORD, 0xffffffffL).shiftLeft(Data.valueOf(WORD, 0x20).subtract(Data.zeroExtend(WORD, ME.access().load()).subtract(Data.zeroExtend(WORD, MB.access().load())).add(Data.valueOf(WORD, 0x1)))));
      vars__.temp.access().store(vars__.temp.access().load().shiftRight(Data.zeroExtend(WORD, MB.access().load())));
    } else {
      vars__.temp.access().store(Data.valueOf(WORD, 0xffffffffL).shiftLeft(Data.valueOf(WORD, 0x20).subtract(Data.zeroExtend(WORD, MB.access().load()).subtract(Data.zeroExtend(WORD, ME.access().load())).subtract(Data.valueOf(WORD, 0x1)))));
      vars__.temp.access().store(vars__.temp.access().load().shiftRight(Data.zeroExtend(WORD, MB.access().load())).not());
    }
    ra.access(pe__, vars__).store(rs.access(pe__, vars__).load().shiftLeft(SH.access().load()).or(rs.access(pe__, vars__).load().shiftRight(Data.valueOf(SHIFT, 0x0).subtract(SH.access().load()))).and(vars__.temp.access().load()));
    if (Rc_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      if (ra.access(pe__, vars__).load().equals(Data.valueOf(WORD, 0x0))) {
        pe__.CR0_EQ.access().store(Data.valueOf(BIT, 0x1));
      } else if (ra.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(BIT, 0x1))) {
        pe__.CR0_LT.access().store(Data.valueOf(BIT, 0x1));
      } else {
        pe__.CR0_GT.access().store(Data.valueOf(BIT, 0x1));
      }
      pe__.CR0_SO.access().store(pe__.XER_SO.access().load());
    }
  }
}