/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class sl_general_image extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "sl_general_image",
          sl_general_image.class,
          null
          );
      addArgument("rsd", R.INFO);
      addArgument("D", HWORD);
      addArgument("ra", R.INFO);
      addArgument("opcd_op", Type.CARD(6));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rsd = (R) getArgument("rsd", args);
      final Immediate D = (Immediate) getArgument("D", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate opcd_op = (Immediate) getArgument("opcd_op", args);

      return new sl_general_image(rsd, D, ra, opcd_op);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rsd;
  public final Immediate D;
  public final R ra;
  public final Immediate opcd_op;

  public sl_general_image(final R rsd, final Immediate D, final R ra, final Immediate opcd_op) {
    assert R.INFO.isSupported(rsd);
    assert HWORD.equals(D.getType());
    assert R.INFO.isSupported(ra);
    assert Type.CARD(6).equals(opcd_op.getType());

    this.rsd = rsd;
    this.D = D;
    this.ra = ra;
    this.opcd_op = opcd_op;

    addArgument("rsd", rsd);
    addArgument("D", D);
    addArgument("ra", ra);
    addArgument("opcd_op", opcd_op);
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%6s%5s%5s%16s", opcd_op.access().load().toString(), rsd.image(vars__), ra.image(vars__), D.access().load().toString());
  }
}