/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class store_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "store_general",
          store_general.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("D", HWORD);
      addArgument("ra", R.INFO);
      addArgument("upd", BIT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final Immediate D = (Immediate) getArgument("D", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate upd = (Immediate) getArgument("upd", args);

      return new store_general(rs, D, ra, upd);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rs;
  public final Immediate D;
  public final R ra;
  public final Immediate upd;

  public store_general(final R rs, final Immediate D, final R ra, final Immediate upd) {
    assert R.INFO.isSupported(rs);
    assert HWORD.equals(D.getType());
    assert R.INFO.isSupported(ra);
    assert BIT.equals(upd.getType());

    this.rs = rs;
    this.D = D;
    this.ra = ra;
    this.upd = upd;

    addArgument("rs", rs);
    addArgument("D", D);
    addArgument("ra", ra);
    addArgument("upd", upd);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    ra.execute(pe__, vars__);
    if (vars__.gpr_reg_number.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) {
      vars__.temp.access().store(Data.valueOf(WORD, 0x0));
    } else {
      vars__.temp.access().store(ra.access(pe__, vars__).load());
    }
    vars__.temp1.access().store(vars__.temp.access().load().add(Data.cast(WORD, Data.signExtend(WORD, Data.cast(SHORT, D.access().load())))));
    pe__.MEM.access(vars__.temp1.access().bitField(31, 2).load()).store(rs.access(pe__, vars__).load());
    if (upd.access().load().equals(Data.valueOf(BIT, 0x1))) {
      ra.access(pe__, vars__).store(vars__.temp1.access().load());
    }
  }
}