/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.lea_r16label;
import ru.ispras.microtesk.model.x86.mode.R16;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderLea_r16label} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLea_r16label extends DecoderItem {
  private static DecoderLea_r16label instance = null;

  public static DecoderLea_r16label get() {
    if (null == instance) {
      instance = new DecoderLea_r16label();
    }
    return instance;
  }

  private DecoderLea_r16label() {
    super(
        24,
        true,
        "101110000000000000000000",
        "111110000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R16 op1 = null;
    Immediate rel = null;

    if (!matchNextOpc(image, BitVector.valueOf("10111", 2, 5))) {
      return null;
    }

    op1 = (R16) readNextPrimitive(image, DecoderR16.get());
    if (null == op1) {
      return null;
    }

    rel = readNextImmediate(image, SWORD);

    return newResult(new lea_r16label(op1, rel));
  }
}
